

class Error(Exception):
    pass


class HttpError(Error):

    def __init__(self, error, error_description, status_code, url):
        self.error = error
        self.error_description = error_description
        self.status_code = status_code
        self.url = url

    def __repr__(self):
        if self.status_code and self.url:
            return '<%s "%s": %s (%s from %s)>' % \
                   (self.__class__.__name__, self.error, self.error_description, self.status_code, self.url)
        else:
            return '<%s "%s": %s>' % \
                   (self.__class__.__name__, self.error, self.error_description)

    __str__ = __repr__


class BadRequest(HttpError):
    pass


class Unauthorized(HttpError):
    pass


class Forbidden(HttpError):
    pass


class NotFound(HttpError):
    pass


class MethodNotAllowed(HttpError):
    pass


class Conflict(HttpError):
    pass


class InternalServerError(HttpError):
    pass


class UnsupportedURI(Error):
    pass


class InvalidDataFormat(Error):
    pass


class ResourceNotFound(Error):
    pass


class InvalidPathException(Error):

    def __init__(self, path):
        self.path = path
